import 'package:logging/logging.dart';
import 'package:socksproxy/socksproxy.dart';

Future<void> main() async {
  Logger.root.level = Level.ALL;
  Logger.root.onRecord.listen((r) {
    print('${r.time} ${r.level.name} ${r.loggerName} - ${r.message}');
  });
  final logger = Logger('main');
  logger.info("start socks proxy server");
  final server = await SocksServer.bind(2080);
  logger.info(server);
}
