import 'dart:io';

import 'package:logging/logging.dart';

import './conn.dart';

class SocksServer {
  static final _logger = Logger('SocksServer');
  final ServerSocket _serverSocket;

  SocksServer(this._serverSocket) {
    _serve();
  }

  static Future<SocksServer> bind([int port = 1080]) async {
    final serverSocket = await ServerSocket.bind("0.0.0.0", port);
    return SocksServer(serverSocket);
  }

  void _serve() async {
    await for (final socket in _serverSocket) {
      _logger.info(
          'new connection from ${socket.remoteAddress.host}:${socket.remotePort}');
      try {
        SocksConnection(socket);
      } catch (e) {
        _logger.severe("connection error", e);
      }
    }
  }
}
